import type { GetServerSidePropsContext, NextApiRequest, NextApiResponse } from "next";
import type { NextAuthOptions, Session } from "..";
import type { CallbacksOptions } from "../core/types";
declare function NextAuth(options: NextAuthOptions): any;
declare function NextAuth(req: NextApiRequest, res: NextApiResponse, options: NextAuthOptions): any;
export default NextAuth;
declare type GetServerSessionOptions = Partial<Omit<NextAuthOptions, "callbacks">> & {
    callbacks?: Omit<NextAuthOptions['callbacks'], "session"> & {
        session?: (...args: Parameters<CallbacksOptions["session"]>) => any;
    };
};
export declare function unstable_getServerSession<O extends GetServerSessionOptions, R = O["callbacks"] extends {
    session: (...args: any[]) => infer U;
} ? U : Session>(...args: [GetServerSidePropsContext["req"], GetServerSidePropsContext["res"], O] | [NextApiRequest, NextApiResponse, O] | [O] | []): Promise<R | null>;
declare global {
    namespace NodeJS {
        interface ProcessEnv {
            NEXTAUTH_URL?: string;
            VERCEL?: "1";
        }
    }
}
